from __future__ import division

class cdict(object):
    def __init__(self, getter):
        self.getter = getter
        self._dict = {}
    def __getitem__(self, item):
        try:
            return self._dict[item]
        except KeyError:
            self._dict[item] = result = self.getter(item)
            return result

def closest_point_on_line((line_a, line_b), point): 
    ap = point - line_a
    ab = line_b - line_a
    ab2 = (ab*ab).sum()
    ap_ab = (ap*ab).sum()
    t = ap_ab / ab2
    t = max(0, t) # clamp to > 0
    t = min(1, t) # clamp to < 1
    return line_a + ab * t
